// (c)2007 Andy Green <andy@warmcat.com>

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; version 2.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/


// packetspammer <interface> <sleep in us>
// sends 256 byte UDP packets down <interface> as fast as it will accept
// them, sleeping the given amount of us between each packet.

#include <stdio.h>
#include <errno.h>
#include <sys/socket.h>
#include <resolv.h>
#include <string.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <utime.h>
#include <unistd.h>
#include <pthread.h>
#include <time.h>
#include <stdarg.h>
#include <signal.h>
#include <stdlib.h>
#include <dirent.h>
#include <sched.h>
#include <linux/if.h>
#include <linux/if_ether.h>
#include <gcrypt.h>
#include <assert.h>
#include <openssl/ssl.h>
#include <openssl/evp.h>
#include <openssl/err.h>
#include <sys/mman.h>
#include <sys/wait.h>
#include <netdb.h>
#include <string.h>
#include <getopt.h>
#include <syslog.h>

#include <net/ethernet.h>
#include <netpacket/packet.h>
#include <sys/wait.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <stdio.h>
#ifdef USE_LIBFEC_CPUDETECT
#include <ifaddrs.h>
#endif
#include <string.h>
#include <getopt.h>
#include <syslog.h>
#include <sys/ioctl.h>
#include <pcap.h>

#define __user
#include "wireless.20.h"

typedef unsigned char u8;

int flagHelp=0;
#define MAX_PENUMBRA_INTERFACES 8
static const u8 u8aIeeeHeader[] = {
		0x08, 0x01, 0x00, 0x00,
		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
		0x13, 0x22, 0x33, 0x44, 0x55, 0x66,
		0x13, 0x22, 0x33, 0x44, 0x55, 0x66,
		0x10, 0x86,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

// magic incantation to bring up a management interface

int ManagementInterface(const char * szInterface, int nCreateOrDestroy, char *szManagementInterfaceName)
{

	#define PRISM2_PARAM_MGMT_IF 1046
	{
		struct iwreq wrq;
		int sock=socket(PF_INET, SOCK_STREAM, 0);
		int * pi=(int *)wrq.u.name;
		struct dirent * pdi=NULL;

		if(sock<1) {
			perror("unable to create socket\n");
			return(1);
		}
	
		strncpy(wrq.ifr_name, szInterface, IFNAMSIZ);

		pi[0]=PRISM2_PARAM_MGMT_IF;
		pi[1]=nCreateOrDestroy;

		if(ioctl(sock, SIOCIWFIRSTPRIV+0, &wrq)==0) {
			if(nCreateOrDestroy) {
				DIR *pdir=opendir("/sys/class/ieee80211/");
				struct stat sstat;
				do {
			
					if( (pdi=readdir(pdir)) == NULL ) continue;
			
					if( (strncmp(pdi->d_name, "wiphy", 5)==0) || (strncmp(pdi->d_name, "phy", 3)==0) ) { // wiphyn
						char szPath[PATH_MAX];
						
						sprintf(szPath, "/sys/class/ieee80211/%s/device/net:%s",
							pdi->d_name, szInterface);
						szManagementInterfaceName[0]='\0';
						if(stat(szPath, &sstat)==0) {	 // this wiphy device has own main IF
							int n=0;
							while(n<MAX_PENUMBRA_INTERFACES) {
								sprintf(szPath, "/sys/class/ieee80211/%s/device/net:wmgmt%d",
									pdi->d_name, n);
								if(stat(szPath, &sstat)==0) {	 // yeah this is our mgmt if
									sprintf(szManagementInterfaceName, "wmgmt%d", n);
									printf("     %s mgt interface for %s added\n", szManagementInterfaceName, szInterface);
									n=MAX_PENUMBRA_INTERFACES;
									pdi=NULL;
								}
								n++;
							}
						}
					}

				} while(pdi!=NULL);

				closedir(pdir);

				if(!szManagementInterfaceName[0]) {
					printf("Failed to find wmgmt interface associated with %s\n", szInterface);
				}

			} else {
				printf("mgt interface for %s destroyed\n", szInterface);
			}
			close(sock);
			return 0;
		} else {
			perror("mgt ioctl failed - are you root?");
		}
		close(sock);
		return 1;
	}
}


int main(int argc, char *argv[])
{
	u8 u8aSendBuffer[300];
	char szErrbuf[PATH_MAX], szMgtInterfaceName[IFNAMSIZ];
	int nCaptureHeaderLength=0, n80211HeaderLength=0, nLinkEncap=0;
	int nOrdinal=0, r;
	pcap_t *ppcap=NULL;

	printf("Packetspammer (c)2007 Andy Green <andy@warmcat.com>\n Spamming at %uus sleep\n", (unsigned int)atoi(argv[2]));

	if(argc<3) {
		printf("Usage %s <interface name> <sleep between packets in us>\n", argv[0]);
		exit(1);
	}


		if(ManagementInterface(argv[1], 1, szMgtInterfaceName)!=0) {
			// creates something like this: wmgmt0
			perror("unable to create management interface associated with interface");
			return(1);
		}

			// open the management interface in pcap

		szErrbuf[0]='\0';
		ppcap=pcap_open_live(szMgtInterfaceName, 800, 1, 20, szErrbuf);
		if(ppcap==NULL) {
			printf("Unable to open mgt interface in pcap: %s\n", szErrbuf);
			return(1);
		}

		nLinkEncap=pcap_datalink(ppcap);
		nCaptureHeaderLength=0;

		switch(nLinkEncap) {
	
			case DLT_PRISM_HEADER:
				printf("DLT_PRISM_HEADER Encap\n");
				nCaptureHeaderLength=0x40;
				n80211HeaderLength=0x20; // ieee80211 comes after this
				break;

			default:
				printf("!!! unknown encapsulation on %s !!!\n", argv[1]);
				return 1;

		}


	while(1) {

		memset(u8aSendBuffer, 0, sizeof(u8aIeeeHeader)+256 );
		memcpy(u8aSendBuffer, u8aIeeeHeader, sizeof(u8aIeeeHeader));
		r=sprintf((char *)&u8aSendBuffer[sizeof(u8aIeeeHeader)], "Packetspammer broadcast packet %d", nOrdinal++);
		r=pcap_inject(ppcap, u8aSendBuffer, sizeof(u8aIeeeHeader)+256);
		if(r!=(sizeof(u8aIeeeHeader)+256)) {
			perror("Trouble injecting packet");
			return(1);
		}
		if(atoi(argv[2])) usleep((unsigned int)atoi(argv[2]));
	}

	return(0);
}

